auth.py
import datetime
import flask_mail

from flask import Blueprint, render_template, redirect, url_for, request, flash
from flask_login import login_user, login_required, logout_user, current_user
from werkzeug.security import generate_password_hash, check_password_hash

from .app import app
from .app import mail
from .models import *

auth = Blueprint('auth', __name__)


@auth.route("/login/")
def login():
    return render_template(
        "login.html",
        title="Login"
    )


@auth.route("/logout")
@login_required
def logout():
    logout_user()
    return redirect(url_for("home"))


@auth.route("/login/", methods=['POST'])
def login_post():
    login = request.form.get('login')
    password = request.form.get('password')
    user = ORM.find_by_login(login)
    if not user or not check_password_hash(user.mdp, password):
        flash('Vérifiez vos identifiants et réessayez', 'error')
        return redirect(url_for('auth.login'))
    login_user(user)
    return redirect(url_for("home"))

templates/base.html
<!doctype html>
<html lang="fr">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
    <title>{{ title }}</title>
    <link rel="stylesheet" href="{{ url_for('static',filename='bootstrap/css/bootstrap.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='fonts/font-awesome.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='fonts/ionicons.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='css/bootstrap/Footer-Dark.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='css/navbar.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='css/base.css') }}">
    {% if current_user.admin %}
    <link rel="stylesheet" href="{{ url_for('static',filename='css/menu_deroulant_admin.css') }}">
    {% else %}
    <link rel="stylesheet" href="{{ url_for('static',filename='css/menu_deroulant.css') }}">
    {% endif %}
    {% block style %}{% endblock %}
    <script src="{{ url_for('static',filename='js/jquery.min.js') }}"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.js"> </script>
    <script src="{{ url_for('static',filename='bootstrap/js/bootstrap.min.js') }}"></script>
    {% block headscript %}{% endblock %}
</head>

<body>
    <div class="nav">
        <nav class="navbar navbar-light navbar-expand-md fixed-top nav">
            <div class="container-fluid">
                <button data-toggle="collapse" class="navbar-toggler" data-target="#navcol-1">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navcol-1">
                    <div id = "div_logo"> 
                        <a class="nav-link" href="{{ url_for('home') }}"> <img src="{{url_for('static', filename = 'img/logo.png')}}" alt="logo accessigne" class = "logo"> </a>
                    </div>
                    {% if current_user.is_authenticated %}
                    <ul class="nav navbar-nav ulAuth">
                        <li class="nav-item deroulant">
                            {% if current_user.admin %}
                            <a href="#"><i class="fa fa-user-secret"></i> {{ current_user.nom }}</a>
                            {% else %}
                            <a href="#"><i class="fa fa-user"></i> {{ current_user.nom }}</a>
                            {% endif %}
                            <ul class="sous">
                                <li><a href="/utilisateur/profile/{{current_user.id}}">Mon Profil</a></li>
                                {% if current_user.role == "Implenteur" %}
                                <li><a href="{{ url_for('afficher_utilisateurs') }}">Gérer les utilisateurs</a></li>
                                <li><a href="{{ url_for('afficher_produits') }}">Gérer les produits</a></li>

                                {% endif %}
                                <li><a href="{{ url_for('auth.logout') }}">Se déconnecter</a></li>
                            </ul>
                        </li>
                    </ul>
                    {% else %}
                    <ul class="nav navbar-nav ulAuth">
                        <li class="nav-item"><a class="nav-link" href="{{ url_for('auth.login') }}">Connexion</a></li>
                    </ul>
                    {% endif %}
                </div>
            </div>
        </nav>
    </div>
    <div id="div_flash">
        {% with messages = get_flashed_messages(category_filter=["error"]) %}
        {% if messages %}
        <div class="alert block-message alert-danger mb-3" role="alert">
            <ul class=flashes>
                {% for message in messages %}
                <li>{{ message }}</li>
                {% endfor %}
            </ul>
        </div>
        {% endif %}
        {% endwith %}

        {% with messages = get_flashed_messages(category_filter=["success"]) %}
        {% if messages %}
        <div class="alert block-message alert-success mb-3" role="alert">
            <ul class=flashes>
                {% for message in messages %}
                <li>{{ message }}</li>
                {% endfor %}
            </ul>
        </div>
        {% endif %}
        {% endwith %}
    </div>
    <div id = "page">
        {% block main %} {% endblock %}
    </div>

    <footer class="footer-dark">
        <div class="container">
            <div class="row">
                <div class="col-sm-6 col-md-3 item">
                    <h3>À propos</h3>
                    <ul>
                        <li><a href="#">Ce site web a été développé dans le cadre d'un stage d'un étudiant
                                de l'IUT Informatique d'Orléans. Il s'agit d'un site web conçu en Flask. </a></li>
                    </ul>
                </div>
                <div class="col-sm-6 col-md-3 item">
                    <h3>Contact</h3>
                    <ul>
                        <li><a href="#">Mail : contact@accessigne.fr</a></li>
                    </ul>
                </div>
                <div class="col-md-6 item text">
                    <h3>Accessigne</h3>
                    <p>
                        Accessigne est votre entreprise d'expert en signalétique 
                        situé à Troyes
                    </p>
                </div>
                <div class="col item social">
                    <a target="_blank" href="https://www.facebook.com/accessignetroyes"><i
                            class="icon ion-social-facebook"></i></a>
                    <a target="_blank" href="https://www.accessigne.fr/"><i class="icon ion-link"></i></a>
                </div>
            </div>
            <p class="copyright"> Accessigne © 2020-2021</p>
        </div>
    </footer>
    
    {% block script %}{% endblock %}
</body>

templates/home.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/home.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">
    <h1> {{titre}} </h1>
    <div class = "option">
        <form action="{{ url_for('search') }}" method="POST">
            <div style="display: flex; margin-bottom: 2em;">
                <input type = "text" class = "form-control" name = "recherche">
                <button class = "btn btn-primary" type = "submit"> rechercher </button>
            </div>
            {% if current_user.role == "Implenteur" %}
            <div class = "nouveau">
                <button class = "btn btn-primary" type = 'button'  onclick="window.location.href='/projet/creer'"> Nouveau projet </button>
            </div>
            {% endif %}
        </form>
    </div>
    <div class = "contenant">
        <div class="row row-cols-1 row-cols-md-3 g-4">
        {% for projet in projets %}
                <div class="col" style="margin-bottom: 1em;">
                    <div class="card h-100 text-center">
                        <div class="card-body">
                        <h5 class="card-title"> {{projet.intitule}}</h5>
                        <p class="card-text">
                            <p> <b> Participants : </b>
                                 {% for util in projet.utilisateurs %} 
                                    {{util.nom}}
                                {% endfor %}        
                            </p>
                        <p class="card-text"> <b> Débuté le : </b> {{projet.date_deb}} </p>
                        <div class = "les_boutons">
                            <button class = "btn btn-primary" onclick="window.location.href = '/projet/{{projet.id}}'" > Afficher </button>
                            <button class = "btn btn-danger" onclick="window.location.href='/projet/{{projet.id}}/quit'"> Quitter </button>
                        </div>
                    </div>
                </div>
          </div>
        {% endfor %}
    </div>
</section>

{% endblock %}

templates/login.html
<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
    <title>Connexion</title>
    <link rel="stylesheet" href="{{ url_for('static',filename='bootstrap/css/bootstrap.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static',filename='css/bootstrap/Login-Form-Clean.css') }}">
</head>

<body>
    <div class="login-clean">
        <form method="post" action="{{ url_for('auth.login_post') }}">
            <h2 class="sr-only">Login Form</h2>
            <div class="illustration"><img src="{{ url_for('static',filename='img/logo.png') }}"
                    style="width: 150px;min-width: auto;"></div>
            {% with messages = get_flashed_messages() %}
            {% if messages %}
            <div class="notification is-danger" style="margin: 1em auto;">
                <p style="color:red;text-align: center;">{{ messages[0] }}</p>
            </div>
            {% endif %}
            {% endwith %}
            <div class="form-group"><input class="form-control" type="text" name="login" placeholder="prenom.nom"></div>
            <div class="form-group"><input class="form-control" type="password" name="password"
                    placeholder="Mot de passe"></div>
            <div class="form-group">
                <button class="btn btn-primary btn-block" type="submit" style="background: rgb(63,123,139);">Se
                    connecter
                </button>
            </div>
            <a class="forgot" href="#">Mot de passe oublié ?</a>
        </form>
    </div>
    <script src="{{ url_for('static',filename='js/jquery.min.js') }}"></script>
    <script src="{{ url_for('static',filename='bootstrap/js/bootstrap.min.js') }}"></script>
</body>

</html>

templates/nouveau_produit.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/home.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">
<form method="POST" action="{{ url_for('nouveau_produit_post') }}">
    <div class="form-row profile-row">
        <div >
            <h1>{{titre}}</h1>
            <hr>
            <div class="form-group">
                <label> Nom </label>
                <input class="form-control" type="text" name="nom" required>
            </div>
            <div class="form-group">
                <label>Description</label>
                <textarea class = "form-control" name="description" rows="5" required></textarea>
            </div>
            <hr>
        </div>
    </div>
    <div class="form-row" style = "justify-content: space-around; margin-bottom: 1em;">
            <button class="btn btn-danger form-btn" onclick="window.location.href = '/produits'">Annuler</button>
            <button class="btn btn-primary form-btn" type="submit">Enregistrer</button>
    </div>
</form>
</div>
</section>

{% endblock %}

templates/nouveau_projet.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/nouveau_projet.css') }}">
{% endblock %}
{% block main %}

<main class="d-flex flex-column align-items-center edt">
    <h1>{{titre}}</h1>
    <form id="form1" method="POST" action="{{ url_for('nouveau_projet_post') }}">
        {% with messages = get_flashed_messages() %}
        {% if messages %}
        <div class="notification is-danger" style="margin: 1em auto;">
            <p style="color:red;text-align: center;">{{ messages[0] }}</p>
        </div>
        {% endif %}
        {% endwith %}
        <div>
            <div>
                <hr>
                <div class="valeurs">
                    <div class="form-group">
                        <label> Intitule </label>
                        <input class="form-control" type="text" name="intitule" required>
                        <label for="date"> Date de début </label>
                        <input class="form-control" type="date" name="date_deb" id="date_deb" required>
                    </div>
                    <div class="form-group">
                        <label> Utilisateurs participants au projet </label>
                        <div id="input-joueurs">
                            <input class="form-control" list="utilisateurs" name="utilisateur" id="utilisateur">
                            <datalist id="utilisateurs">
                                {% for user in users %}
                                <option value="{{ user }}">
                                    {% endfor %}
                            </datalist>
                            <input type="text" id="inputParticipants" name="participants">
                            <button class = "btn btn-secondary" type="button" onclick="ajoutParticipants()">Ajouter</button>
                        </div>
                        <div>
                            <ul id="liste_participant"></ul>
                        </div>
                    </div>
                </div>

            </div>

            <div class="form-row" style="justify-content: space-around;">
                <button class="btn btn-danger form-btn" onclick="window.location.href = '/'">ANNULER</button>
                <button class="btn btn-primary form-btn" type="button" onclick="submitForm()">ENREGISTRER</button>
            </div>
    </form>
    </div>
</main>
{% endblock %}
{% block script %}
<script>
    let ensParticipants = new Set()
    ajoutParticipants = function () {
        let valeur = document.getElementById('utilisateur').value;
        if (valeur != "" && !ensParticipants.has(valeur)) {
            ensParticipants.add(valeur);
            let ul = document.getElementById('liste_participant');
            let li = document.createElement('li');
            let p = document.createElement('span');
            let b = document.createElement('button');
            p.style.margin = "1em";
            b.classList = "btn btn-secondary";
            b.innerText = 'Supprimer';
            b.id = valeur;
            p.innerText = valeur;
            li.appendChild(p);
            li.appendChild(b);
            li.id = "li_participant";
            ul.appendChild(li);

            b.onclick = function () {
                let a = this.parentNode;
                console.log(this.id);
                ensParticipants.delete(this.id)
                a.remove(); 
            };
        }
    }
    submitForm = function () {
        let listeParticipants = [];
        for (str of ensParticipants) {
            listeParticipants.push(str);
        }
        document.getElementById("inputParticipants").value = listeParticipants.join(",")
        document.forms["form1"].submit();
    }
</script>
{% endblock %}

templates/nouvel_utilisateur.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/home.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">
<form method="POST" action="{{ url_for('nouvel_utilisateur_post') }}">
    <div class="form-row profile-row">
        <div >
            <h1>{{titre}}</h1>
            <hr>
            <div class="form-group">
                <label> Nom </label>
                <input class="form-control" type="text" name="nom" required>
            </div>
            <div class="form-group">
                <label>Prénom</label>
                <input class="form-control" type="text" name="prenom" required>
            </div>
            <div class="form-group">
                <label>Identifiant</label>
                <input class="form-control" type="text" name="identifiant" required>
            </div>
            <div class="form-group">
                    <label>Rôle</label>
                    <select class="form-control" name = "role" aria-label="Rôle" required>
                        <option value="Client">Client</option>
                        <option value="Architect">Architect</option>
                        <option value="Poseur">Poseur</option>
                        <option value="Implenteur">Implenteur</option>
                      </select>
            </div>
            <div class="form-group">
                <label>Email</label>
                <input class="form-control" type="email" autocomplete="off" name="email" required>
            </div>
            <div class="form-group">
                <label>Mot de passe</label>
                <input class="form-control" type="password" name="password" autocomplete="off"
                    title="Ce champ attend au moins 8 caractères alphanumériques."
                    pattern=".[a-zA-Z0-9]{7,}" required>
            </div>
            <div class="form-group">
                <label>Confirmation du mot de passe</label>
                <input class="form-control" type="password" name="confirmpass" autocomplete="off"
                            required>
            </div>
            <hr>
        </div>
    </div>
    <div class="form-row" style = "justify-content: space-around; margin-bottom: 1em;">
            <button class="btn btn-danger form-btn" onclick="window.location.href = '/'">Annuler</button>
            <button class="btn btn-primary form-btn" type="submit">Enregistrer</button>
    </div>
</form>
</div>
</section>

{% endblock %}

templates/produits.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/home.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">
    <h1> {{titre}} </h1>
    <div class = "option">
        <form action="{{ url_for('recherche_produit') }}" method="POST" id = "form-1">
            <div style="display: flex;">
                <input type = "text" class = "form-control" name = "recherche">
                <button class = "btn btn-primary" type = "button" onclick="submitForm('form-1')" form="form-1"> rechercher </button>
            </div>
        </form>
        <div class = "nouveau">
            <button class = "btn btn-primary" type = 'button'  onclick="window.location.href='/produits/nouveau'" style="margin-bottom: 1em; margin-right: 1em;"> Nouveau Produit </button>
            <button class="btn btn-success" style="margin-bottom: 1em; margin-right: 1em;"
            onclick="document.getElementById('file').click(); ">Importer un .csv
    </button> 
        </div>
        
    <form method="POST" action="{{url_for('import_csv')}}" enctype="multipart/form-data" id = "form-2">
                    
        <input id="file" type="file" accept=".csv" name="file" style="display: none;" />
        <input id="submit_importCSV" type="button" onclick="submitForm('form-2')" style="display: none;" />
</form>
    </div>
    <form action="{{url_for('supprimer_produit')}}" method="POST" id = "suppr_form" >
        <input type="hidden" value = "1" name = "prod_id" id = "prod_id">
    </form>
    <div class = "contenant">
        <div class="row row-cols-1 row-cols-md-3 g-4">
            {% for produit in produits %}
                <div class="col" style="margin-bottom: 1em;">
                    <div class="card h-100 text-center">
                        <div class="card-body">
                        <h5 class="card-title"> {{produit.modele}}</h5>
                        <p class="card-text"> <b> Description : </b> {{produit.description}} </p>
                        <button class="btn btn-danger" onclick="submitProduit('{{produit.id}}')" > Supprimer </button>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
</section>

{% endblock %}
{% block script %}

<!-- <script src="{{ url_for('static',filename='js/bs-init.js') }}"></script> -->
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.8/jquery.min.js"></script>
<script>
    submitForm = function (id_form) {   
        console.log("sub");     
        document.forms[id_form].submit();
    }
    $("#file").change(function () {
        console.log("here");
        document.getElementById("form-2").submit();    
        });

    function submitProduit(id){
        let input = document.getElementById("prod_id");
        input.value = id;
        document.forms["suppr_form"].submit();
    }
</script>
{% endblock %}

templates/profil_modif.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/profil.css') }}">
<link rel="stylesheet" href="{{ url_for('static',filename='css/profil_modif.css') }}">

{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">

    <h1> {{titre}} </h1>
    <div class = "deux_div">
        <div class = "infos">
            <h4> Mes informations </h4>
            <div>
                <form action="{{ url_for('modif_profile_post')}}" method="POST" id = form-1>
                <ul>
                    <input type="hidden" name="id" value="{{user.id}}">
                    <li><label><b> Nom :</b>  </label> <input type="text" class = "form-control" name = "nom" value="{{user.nom}}" ></li>
                    <li><label><b> Prenom :</b>  </label> <input type="text" class = "form-control" name = "prenom" value="{{user.prenom}}" ></li>
                    {% if current_user.role != "Implenteur" %}
                        <li><label><b> identifiant :</b></label> <input type="text" class = "form-control" name = "login" value="{{user.login}}" disabled> </li>
                        <li><label><b> Rôle :</b></label> <input type="text" class = "form-control" name = "role" value="{{user.role}}" disabled> </li>
                    {% else %}
                        <li><label><b> identifiant :</b></label> <input type="text" class = "form-control" name = "login" value="{{user.login}}"> </li>
                        <li><label><b> Rôle :</b></label> <input type="text" class = "form-control" name = "role" value="{{user.role}}"> </li>
                    {% endif %}
                    <li><label><b> Email :</b></label> <input type="text" class = "form-control" name = "mail" value="{{user.mail}}"> </li>
                    <li><label><b> Mot de passe :</b></label> <input type="text" class = "form-control" name = "password"> </li>
                    <li><label><b> Confirmation :</b></label> <input type="text" class = "form-control" name = "confirmpass"> </li>

                </ul>
                </form>
            </div>
        </div>
    
        <div class = "projets">
            <h4> Mes projets </h4>
            <ul>
                {% for projet in projets %}
                <li>
                    <p> {{projet.intitule}} </p>
                    <button class="btn btn-danger"> Quitter </button>
                </li>
                {% endfor %}
            </ul>
            
        </div>
    </div>
    <form action="{{url_for('supression_profile_post')}}" method="POST" id = "form-2">
        <input type="hidden" name="id" value="{{user.id}}">
    </form>
    <div class = "div_bouton">
        <button class = "btn btn-primary" type="submit"  form="form-1"> Valider </button>
        <button class = "btn btn-danger" type = "submit" form = "form-2"> Supprimer </button>
    </div> 
    

</section>


{% endblock %}

templates/profile.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/profil.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">

    <h1> {{titre}} </h1>
    <div class = "deux_div">
        <div class = "infos">
            <h4> Mes informations </h4>
            <div>
                <ul>
                    <li><p><b> Nom :</b> {{user.nom}} </p></li>
                    <li><p><b> Prenom :</b> {{user.prenom}} </p></li>
                    <li><p><b> identifiant :</b> {{user.login}} </p></li>
                    <li><p><b> Rôle :</b> {{user.role}} </p></li>
                </ul>
            </div>
        </div>
    
        <div class = "projets">
            <h4> Mes projets </h4>
            <ul>
                {% for projet in projets %}
                <li>
                    <p> {{projet.intitule}} </p>
                </li>
                {% endfor %}
            </ul>
            
        </div>
    </div>

    <form action="{{url_for('supression_profile_post')}}" method="POST" id = "form-2">
        <input type="hidden" name="id" value="{{user.id}}">
    </form>
    <div class = "div_bouton">
        <button class = "btn btn-primary" onclick="window.location.href='/utilisateur/profile/{{user.id}}/modif'"> Modifier </button>
        <button class = "btn btn-danger" type = "submit" form = "form-2"> Supprimer </button>
    </div>
    

</section>


{% endblock %}

templates/utilisateurs.html
{% extends "base.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for('static',filename='css/home.css') }}">
{% endblock %}

{% block main %}

<section class="d-flex flex-column align-items-center edt">
    <h1> {{titre}} </h1>
    <div class = "option">
        <form action="{{ url_for('recherche_utilisateur') }}" method="POST">
            <div style="display: flex;">

                <input type = "text" class = "form-control" name = "recherche">
                <select name="precision" class = "form-control">
                    <option value="nom" selected> nom </option>
                    <option value="prenom"> prenom </option>
                </select>
                <button class = "btn btn-primary" type = "submit"> rechercher </button>
            </div>
            {% if current_user.role == "Implenteur" %}
            <div class = "nouveau">
                <button class = "btn btn-primary" type = 'button'  onclick="window.location.href='/utilisateur/creer'" style="margin-bottom: 1em;"> Nouvel utilisateur </button>
            </div>
            {% endif %}
        </form>
    </div>
    <div class = "contenant">
        <div class="row row-cols-1 row-cols-md-3 g-4">
            {% for user in users %}
                <div class="col" style="margin-bottom: 1em;">
                    <div class="card h-100 text-center">
                        <div class="card-body">
                        <h5 class="card-title"> {{user.nom}} {{user.prenom}}</h5>
                        <p class="card-text"> <b> Identifiant : </b> {{user.login}} </p>
                        <p class="card-text"> <b> Rôle : </b> {{user.role}} </p>
                        <button class="btn btn-primary" onclick="window.location.href='/utilisateur/profile/{{user.id}}'" > Afficher </button>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
</section>

{% endblock %}